﻿using System;
using System.Collections;
using System.Text;

namespace RecognizeSignature.DataBase
{

    public class Person:Root
	{
        // Статични данни на класа
        new protected string tableName = "Person";
        new protected string[] columns = { "EGN", "F_name", "S_name", "L_name", "Sex" };

        //Errors
        public static string ErrorEGN = "ЕГН е грешно или не са попълнени трите имена. Моля, въведете данните отново!";
        // Данни на класа
        private string egn;
        private string fName;
        private string sName;
        private string lName;
        //1 - male; 0 - female
        private int sex;

        // Пропартита на класа
        public override string DisplayId
        {
            get { return fName + " " + sName + " " + lName; }
        }

        public string ShortDisplayId
        {
            get { return fName.Substring(0, 1) + ".  " + lName; }
        }

        public string EGN
        {
            get { return egn; }
        }

        public string F_name
        {
            get { return fName; }
        }
        public string S_name
        {
            get { return sName; }
        }
        public string L_name
        {
            get { return lName; }
        }
        public int Sex
        {
            get { return sex; }
        }
        public override string[] Columns
        {
            get
            {
                return columns;
            }

            set
            {
                columns = value;
            }
        }

        

        public override string TableName
        {
            get
            {
                return tableName;
            }

            set
            {
                tableName = value;
            }
        }

       

        //Статични методи на класа
        public static Person CreateCorrectInstance(string egn, string fName, string sName, string lName)
        {

            if (IsEgn(egn))
            {
                return new Person(egn, fName,  sName,  lName );
            }
            else
                return null;
        }
        //Констрикдури на класа
        public Person(string egn, string fName, string sName, string lName)
        {
            TableName = "Person";
            Columns = columns;
            this.egn =   egn;
            this.fName = fName;
            this.sName = sName;
            this.lName = lName;
            this.sex = Pol(egn);
        }

        public Person()
        {
        }

        //Методи на класа
        public override Hashtable GetValues()
        {
            Hashtable hashTable = base.GetValues();
            hashTable.Add(columns[0], egn);
            hashTable.Add(columns[1], fName);
            hashTable.Add(columns[2], sName);
            hashTable.Add(columns[3], lName);
            hashTable.Add(columns[4], sex);
            return hashTable;
        }

        public override void SetValues(Hashtable hashTable)
        {
            base.SetValues(hashTable);
            foreach (string key in hashTable.Keys)
            {
                switch (key)
                {
                    case "EGN":
                        egn = hashTable[key].ToString();
                        continue;
                    case "F_name":
                        fName = hashTable[key].ToString();
                        continue;
                    case "S_name":
                        sName = hashTable[key].ToString();
                        continue;
                    case "L_name":
                        lName = hashTable[key].ToString();
                        continue;
                    case "Sex":
                        sex = (int)hashTable[key];
                        continue;
                }
            }
        }

        public override Root CreateInstance()
        {
            return new Person();
        }

        public  int Pol(string Egn)
        {
            int sex;
            if (int.Parse(Egn[8].ToString()) % 2 == 0)
            {
                sex = 0;
            }
            else
            {
                sex = 1;
            }
            return sex;
        }

        //>>100++
        public static DateTime BirthDate(string Egn)
        {
            string day = Egn.Substring(4, 2);
            string month = Egn.Substring(2, 2);
            string year = Egn.Substring(0, 2);
            if (month[0] == '0' || month[0] == '1')
                year = "19" + year;

            if (month[0] == '2' || month[0] == '3')
            {
                int m = int.Parse(month);
                m -= 20;
                month = m.ToString();
                year = "18" + year;
            }
            if (month[0] == '4' || month[0] == '5')
            {
                int m = int.Parse(month);
                m -= 40;
                month = m.ToString();
                year = "20" + year;
            }
            DateTime time = new DateTime(int.Parse(year), int.Parse(month), int.Parse(day));

            return time;
        }
        //>>

        public static bool IsEgn(string Egn)
        {
            int[] tegla = { 2, 4, 8, 5, 10, 9, 7, 3, 6 };

            if (Egn.Length != 10) return false;
            string day = Egn.Substring(4, 2);
            string month = Egn.Substring(2, 2);
            string year = Egn.Substring(0, 2);
            if (month[0] == '0' || month[0] == '1')
                year = "19" + year;

            if (month[0] == '2' || month[0] == '3')
            {
                int m = int.Parse(month);
                m -= 20;
                month = m.ToString();
                year = "18" + year;
            }
            if (month[0] == '4' || month[0] == '5')
            {
                int m = int.Parse(month);
                m -= 40;
                month = m.ToString();
                year = "20" + year;
            }
            try
            {
                DateTime time = new DateTime(int.Parse(year), int.Parse(month), int.Parse(day));
            }
            catch
            {
                return false;
            }

            int sum = 0;
            int j = 0;
            foreach (int teg in tegla)
            {
                sum += int.Parse(Egn[j++].ToString()) * teg;
            }

            sum = sum % 11;
            if (sum == 10) sum = 0;
            if (sum.ToString() != Egn[9].ToString()) return false;
            return true;
        }

        //>>101
        public static Person GetPersonById(object idPerson)
        {
            Person p = new Person();
            object[] o = p.Find("[Id] = " + idPerson);
            if (o.Length == 0) return null;
            return (Person)o[0];
        }
        //>>
		
	}
}


