﻿using System;
using System.Text;
using System.Collections;

namespace RecognizeSignature.DataBase
{
    public class Signature:Root
    {

        // Статични данни на класа
        new protected string tableName = "Signature";
        new protected string[] columns = { "Distance", "Angle", "DispersiaX", "DispersiaY", "DispersiaP", "SignBinary", 
                                           "Id_Person","NumberStrokes","NumberPixels","Width","Length","Complexity","Kind" };

        int    idPerson;
        double distance;
        double angle;
        double dispersiaX;
        double dispersiaY;
        double dispersiaP;
        string signBinary;
		int    numberStrokes;
		int    numberPixels;
		int    width;
		double length;
		double complexity;
		int    kind;  // 0- data; 1-etalon;


		public int IdPerson
		{
			get{ return idPerson;}
		}
		public double Distance
		{
			get { return distance;}
		}
		
		public double Angle
		{
			get { return angle;}
		}

		public double DispersiaX
        {
			get {return dispersiaX;}
		}
		
		public double DispersiaY
		{
			get{ return dispersiaY;}
		}

		public double DispersiaP
		{
			get { return dispersiaP;}
		}

	
		public int    NumberStrokes
		{
			get { return numberStrokes;}
		}

		public int    NumberPixels
		{
			get { return numberPixels;}
		}
		
		public int    Width
		{
			get { return width;}
		}

		public double Length
		{
			get { return length;}
		}

		public double Complexity
		{
			get { return complexity;}
		}

        public override string[] Columns
        {
            get
            {
                return columns;
            }

            set
            {
                columns = value;
            }
        }

        

        public override string TableName
        {
            get
            {
                return tableName;
            }

            set
            {
                tableName = value;
            }
        }

		public static void CalculateEtalon(int idPerson)
		{
			Signature sg = new Signature();
			string constraint = "Id_Person="+idPerson + " and Kind = 0";
			object [] signExist  = sg.Find( constraint );

			ArrayList Arraydistance = new ArrayList();
			ArrayList Arrayangle   = new ArrayList();
			ArrayList ArraydispersiaX   = new ArrayList();
			ArrayList ArraydispersiaY    = new ArrayList();
			ArrayList ArraydispersiaP    = new ArrayList();
			ArrayList ArraynumberStrokes    = new ArrayList();
			ArrayList ArraynumberPixels     = new ArrayList();
			ArrayList Arraywidth            = new ArrayList();
			ArrayList Arraylength        = new ArrayList();
			ArrayList Arraycomplexity    = new ArrayList();

			for(int i=0; i < signExist.Length; i++)
			{
				sg = (Signature)signExist[i];
				Arraydistance.Add(sg.distance);
				Arrayangle.Add(sg.angle);
				ArraydispersiaX.Add(sg.dispersiaX);
				ArraydispersiaY.Add(sg.dispersiaY);
				ArraydispersiaP.Add(sg.dispersiaP);
				ArraynumberStrokes.Add(sg.numberStrokes);
				ArraynumberPixels.Add(sg.numberPixels);
				Arraywidth.Add(sg.width);
				Arraylength.Add(sg.length);
				Arraycomplexity.Add(sg.complexity);

			}
			double distance      = SignCalculateData.SrednoAritmetichno(Arraydistance);
			double angle         = SignCalculateData.SrednoAritmetichno(Arrayangle);
			double dispersiaX    = SignCalculateData.SrednoAritmetichno(ArraydispersiaX);
			double dispersiaY    = SignCalculateData.SrednoAritmetichno(ArraydispersiaY);
			double dispersiaP    = SignCalculateData.SrednoAritmetichno(ArraydispersiaP);
			int numberStrokes    = (int)SignCalculateData.SrednoAritmetichno(ArraynumberStrokes);
			int numberPixels     = (int)SignCalculateData.SrednoAritmetichno(ArraynumberPixels);
			int width            = (int)SignCalculateData.SrednoAritmetichno(Arraywidth);
			double length        = SignCalculateData.SrednoAritmetichno(Arraylength);
			double complexity    = SignCalculateData.SrednoAritmetichno(Arraycomplexity);

			constraint = "Id_Person="+idPerson + " and Kind = 1";
			object [] signEtalon  = sg.Find( constraint );
			if ( signEtalon.Length > 0)
			{
				// update data
				sg = (Signature)signEtalon[0];
				sg.distance = distance;
				sg.angle = angle;
				sg.dispersiaX = dispersiaX;
				sg.dispersiaY = dispersiaY;
				sg.dispersiaP = dispersiaP;
				sg.numberStrokes = numberStrokes;
				sg.numberPixels = numberPixels;
				sg.width = width;
				sg.length = length;
				sg.complexity = complexity;

                sg.Update();
			}
			else
			{
				// create data
				sg = new Signature(distance,angle,dispersiaX,dispersiaY,dispersiaP,"",idPerson,numberStrokes,numberPixels,width,length,complexity,1);
				sg.Create();
			}
            
		}

       
        //Констриктури на класа
        public Signature(double distance, double angle, double dispersiaX, double dispersiaY, double dispersiaP, string signBinary, int idPerson,
			             int numberStrokes,int numberPixels, int width, double length, double complexity, int kind)
        {
            TableName          = "Signature";
            Columns            = columns;
            this.distance      = distance;
            this.angle         = angle;
            this.dispersiaX    = dispersiaX;
            this.dispersiaY    = dispersiaY;
            this.dispersiaP    = dispersiaP;
            this.signBinary    = signBinary;
            this.idPerson      = idPerson;
			this.numberStrokes = numberStrokes;
			this.numberPixels  = numberPixels;
			this.width         = width;
			this.length        = length;
			this.complexity    = complexity;
			this.kind          = kind; 
        }

        public Signature()
        {
        }

        //Методи на класа
        public override Hashtable GetValues()
        {
            Hashtable hashTable = base.GetValues();
            hashTable.Add(columns[0], distance);
            hashTable.Add(columns[1], angle);
            hashTable.Add(columns[2], dispersiaX);
            hashTable.Add(columns[3], dispersiaY);
            hashTable.Add(columns[4], dispersiaP);
            hashTable.Add(columns[5], signBinary);
            hashTable.Add(columns[6], idPerson);
			hashTable.Add(columns[7], numberStrokes);
			hashTable.Add(columns[8], numberPixels);
			hashTable.Add(columns[9], width);
			hashTable.Add(columns[10],length);
			hashTable.Add(columns[11],complexity);
			hashTable.Add(columns[12],kind); 
            return hashTable;
        }

        public override void SetValues(Hashtable hashTable)
        {
            base.SetValues(hashTable);
            foreach (string key in hashTable.Keys)
            {
                switch (key)
                {
                    case "Id_Person":
                        idPerson = (int)hashTable[key];
                        continue;
                    case "Distance":
                        distance = double.Parse(hashTable[key].ToString());
                        continue;
                    case "Angle":
                        angle =    double.Parse(hashTable[key].ToString());
                        continue;
                    case "DispersiaX":
                        dispersiaX = double.Parse(hashTable[key].ToString());
                        continue;
                    case "DispersiaY":
                        dispersiaY = double.Parse(hashTable[key].ToString());
                        continue;
                    case "DispersiaP":
                        dispersiaP = double.Parse(hashTable[key].ToString());
                        continue;
                    case "SignBinary":
                        signBinary = (string)hashTable[key];
                        continue;
					case "NumberStrokes":
						numberStrokes = (int)hashTable[key];
						continue;
					case "NumberPixels":
						numberPixels = (int)hashTable[key];
						continue;
					case "Width":
						width = (int)hashTable[key];
						continue;
					case "Length":
						length = double.Parse(hashTable[key].ToString());
						continue;
					case "Complexity":
						complexity = double.Parse(hashTable[key].ToString());
						continue;
					case "Kind":
						kind = (int)hashTable[key];
						continue;
                
                }
            }
        }

        public override Root CreateInstance()
        {
            return new Signature();
        }
    }
}
