﻿using System;
using System.Collections;
using System.Text;
using System.Drawing;
using System.Data;
using Microsoft.Ink;
using System.IO;

namespace RecognizeSignature
{

    class SignProperties
    {
        public SignCalculateData properties;


        public SignProperties(InkCollector myInkCollector)
        {
            Strokes theStrokes = myInkCollector.Ink.Strokes;
            ArrayList xAxis;
            ArrayList yAxis;
            ArrayList normalPressure;
            GetDataFromSrokes(theStrokes, out  xAxis, out  yAxis, out  normalPressure);
            Rectangle theBoundingBox = myInkCollector.Ink.GetBoundingBox(BoundingBoxMode.PointsOnly);
            properties = new SignCalculateData(xAxis, yAxis, normalPressure, theBoundingBox,theStrokes.Count);
        }

        public void GetDataFromSrokes(Strokes theStrokes, out ArrayList xAxis, out ArrayList yAxis, out ArrayList normalPressure)
        {
             xAxis = new ArrayList();
             yAxis = new ArrayList();
             normalPressure = new ArrayList();

            foreach (Stroke theStroke in theStrokes)
            {
               // indexPoint++;
                // Test for the timestamp property on this stroke.
                if (true)//theStroke.ExtendedProperties.DoesPropertyExist(myTimeGuid))
                {
                    // Get the raw data out of this stroke's extended
                    // properties list, using the previously defined
                    // Guid as a key to the wanted extended property.
              // long theLong = (long)theStroke.ExtendedProperties[myTimeGuid].Data;
                    // Then turn it (as a FileTime) into a time string.
              // string theTime = DateTime.FromFileTime(theLong).ToString();


                    //Get cordinate of Point
                    //for( int i=0; i < theStroke.PacketCount;i++)
                    //{

                    Guid[] guidMu = theStroke.PacketDescription;
      
                    int[] theX =
                        theStroke.GetPacketValuesByProperty(PacketProperty.X);
                  
                    int[] theY =
                        theStroke.GetPacketValuesByProperty(PacketProperty.Y);

                    if (IsTypePacketSupport(guidMu, PacketProperty.NormalPressure))
                    {
                        int[] thePressure =
                        theStroke.GetPacketValuesByProperty(PacketProperty.NormalPressure);
                    }
                    //else
                    //{
                        int[] theP = GenerateRondomPressure(theY.Length);
                    //}


                    if (IsTypePacketSupport(guidMu, PacketProperty.TimerTick))
                    {
                        int[] curentTime =
                            theStroke.GetPacketValuesByProperty(PacketProperty.TimerTick);
                    }

                    //  }
                    for (int ii = 0; ii < theY.Length; ii++)
                    {
                        xAxis.Add(theX[ii]);
                        yAxis.Add(theY[ii]);
                        normalPressure.Add(theP[ii]);
                    }
                }
            }
        }

        // This function saves the form in ISF format.
        // It uses ExtendedProperties to preserve the first and last names.
        // ExtendedProperties are an easy way to store non-ink data within an
        // ink object. In this case, there is no outer format which contains the
        // ink, so the only place to store the names is within the ink object itself.
        public  string SaveISF(InkCollector myInkCollector)
        {
            byte[] isf;

            // This is the ink object which will be serialized
            //ExtendedProperties inkProperties = ic.Ink.ExtendedProperties;

            //// Store the name fields in the ink object
            //// These fields will roundtrip through the ISF format
            //// Ignore empty fields since strictly empty strings 
            ////       cannot be stored in ExtendedProperties.
            //if (FirstNameBox.Text.Length > 0)
            //{
            //    inkProperties.Add(FirstName, FirstNameBox.Text);
            //}
            //if (LastNameBox.Text.Length > 0)
            //{
            //    inkProperties.Add(LastName, LastNameBox.Text);
            //}

            // Perform the serialization
            isf = myInkCollector.Ink.Save(PersistenceFormat.InkSerializedFormat);

            // Write the ISF to the stream
            string serilization = "";
            //serilization..Write(isf, 0, isf.Length);
            return serilization;
        }

        private bool IsTypePacketSupport(Guid[] theGuids, Guid theGuid)
        {
            bool flag = false;
            for (int i = 0; i < theGuids.Length; i++)
            {
                if (theGuids[i].Equals(theGuid))
                    flag = true;
            }
            return flag;
        }

        private int[] GenerateRondomPressure(int count)
        {
            Random randObj = new Random();
            int [] pressure = new int[count];
            for (int i = 0; i < count; i++)
            {
                int data = i;// randObj.Next(1024);
               pressure[i] = data;
            }
            return pressure;
        }

		public static string SaveIncCollectorToString(InkCollector myInkCollector)
		{
			// This object will encode our byte data to a UTF8 string
			UTF8Encoding utf8 = new UTF8Encoding();
            
			byte[] base64ISF_bytes;
			string base64ISF_string;


			// Get the base64 encoded ISF
			base64ISF_bytes = myInkCollector.Ink.Save(PersistenceFormat.Base64InkSerializedFormat);

			// Ink.Save returns a null terminated byte array. The encoding of the null
			// character generates a control sequence when it is UTF8 encoded. This
			// sequence is invalid in XML. Therefore, it is necessary to remove the 
			// null character before UTF8 encoding the array.
			// The following loop finds the index of the first non-null byte in the byte 
			// array returned by the Ink.Save method.
			int countOfBytesToConvertIntoString = base64ISF_bytes.Length - 1;
			for(; countOfBytesToConvertIntoString >= 0; --countOfBytesToConvertIntoString)
			{
				// Break the loop if the byte at the index is non-null.
				if(0 != base64ISF_bytes[countOfBytesToConvertIntoString])
					break;
			}

			// Convert the index into count by incrementing it.
			countOfBytesToConvertIntoString++;

			// Convert it to a String
			base64ISF_string = utf8.GetString(base64ISF_bytes, 0, countOfBytesToConvertIntoString);
			return base64ISF_string;
		}
    }
}
